package rapePackageOverrides
{
	function serverCmdUseTool(%client, %slot)
	{
		if(%client.player.isBeingRaped || %client.player.isRaping)
			return;
			
		Parent::serverCmdUseTool(%client, %slot);
	}
	
	function serverCmdUseInventory(%client, %slot)
	{
		if(%client.player.isBeingRaped || %client.player.isRaping)
			return;
			
		Parent::serverCmdUseInventory(%client, %slot);
	}
	
	function serverCmdSuicide(%client)
	{
		if(%client.player.isBeingRaped || %client.player.isRaping)
			return;

		Parent::serverCmdSuicide(%client);
	}
	
	function serverCmdCreateMinigame(%client, %name, %color, %bool)
	{
		if(%client.player.isRaping || %client.player.isBeingRaped)
		{
			return;
		}
	
		Parent::serverCmdCreateMinigame(%client, %name, %color, %bool);
	}
	
	function serverCmdJoinMinigame(%client, %minigame, %a, %b, %c)
	{
		if(%client.player.isRaping || %client.player.isBeingRaped)
		{
			return;
		}
	
		Parent::serverCmdJoinMinigame(%client, %minigame, %a, %b, %c);
	}
	
	function GameConnection::onDrop(%this)
	{
		if(%this.player.isBeingRaped)
		{
			%this.rapist.player.remainingBars = 50;
			
			%this.rapist.player.bars = 0;
		
			%this.rapist.player.isRaping = 0;
			
			%this.rapist.rapeVictim = "";
			
			%this.rapist.player.playThread(0, root);
			%this.rapist.player.playThread(2, root);
			
			%this.rapist.player.unmountImage(1);
			
			%this.rapist.centerPrint("<just:center><color:FF0000>Your rape victim disappeared!", 4);
			
			%this.player.emote(hateImage);
			
			cancel(%this.rapist.player.freezeLoop);
			
		}
		else if(%this.player.isRaping)
		{
			%this.rapeVictim.player.remainingBars = 50;
			
			%this.rapeVictim.player.bars = 0;
		
			%this.rapeVictim.player.isBeingRaped = 0;
			
			%this.rapeVictim.rapist = "";
			
			%this.rapeVictim.player.playThread(0, root);
			
			%this.rapeVictim.centerPrint("<just:center><color:00FF00>Your rapist disappeared!", 4);
			
			cancel(%this.rapeVictim.player.freezeLoop);
		}
		Parent::onDrop(%this);
	}

	
	function GameConnection::onDeath(%this, %sourceObject, %sourceClient, %damageType, %damLoc)
	{
		if(%this.player.isRaping)
		{
			%this.rapeVictim.player.remainingBars = 50;
			
			%this.rapeVictim.player.bars = 0;
			
			%this.rapeVictim.player.playThread(0, root);
			
			%this.rapeVictim.player.isBeingRaped = 0;
			
			%this.rapeVictim.rapist = "";
			
			%this.rapeVictim.centerPrint("<color:00FF00>Your rapist died!", 4);
			
			cancel(%this.rapeVictim.player.freezeLoop);
			
			%this.rapeVictim = "";
		}
		else if(%this.player.isBeingRaped)
		{
			%this.rapist.player.remainingBars = 50;
			
			%this.rapist.player.bars = 0;
		
			%this.rapist.player.playThread(0, root);
			%this.rapist.player.playThread(2, root);
			
			%this.rapist.player.unmountImage(1);
			
			%this.rapist.player.isRaping = 0;
			
			%this.rapist.rapeVictim = "";
			
			%this.rapist.centerPrint("<color:00FF00>Your rape victim died!", 4);
			
			cancel(%this.rapist.player.freezeLoop);
			
			%this.rapist = "";
		}
		Parent::onDeath(%this, %sourceObject, %sourceClient, %damageType, %damLoc);
	}
	
    function WheeledVehicleData::onCollision(%this, %obj, %col, %vec, %vecLen)
    {
		if(%col.isBeingRaped || %col.isRaping )
			return;
			
		Parent::onCollision(%this, %obj, %col, %vec, %vecLen);   
    }
	
	function GameConnection::createPlayer(%this, %spawnPoint)
	{
		if(%this.rapeVictim !$= "")
		{
			%this.rapeVictim.player.remainingBars = 50;
			%this.rapeVictim.player.bars = 0;

			%this.rapeVictim.player.playThread(0, root);

			%this.rapeVictim.player.isBeingRaped = 0;
			%this.rapeVictim.rapist = "";
			
			%this.rapeVictim.centerPrint("<color:00FF00>Your rapist disappeared!", 4);
			
			cancel(%this.rapeVictim.player.freezeLoop);
			
			%this.rapeVictim = "";
		}
		else if(%this.rapist !$= "")
		{
			%this.rapist.player.remainingBars = 50;
			%this.rapist.player.bars = 0;
		
			%this.rapist.player.playThread(0, root);
			%this.rapist.player.playThread(2, root);
			%this.rapist.player.unmountImage(1);
			
			%this.rapist.player.isRaping = 0;
			%this.rapist.rapeVictim = "";
			
			%this.rapist.centerPrint("<color:00FF00>Your rape victim disappeared!", 4);
			
			cancel(%this.rapist.player.freezeLoop);
			
			%this.rapist = "";
		}
		Parent::createPlayer(%this, %spawnPoint);
	}
};
activatePackage(rapePackageOverrides);